#!/usr/bin/env ruby

require 'yaml'
require 'active_support/all'
require 'nokogiri'
require 'progressbar'
require 'ferret'

PROGRESSBAR_OPTIONS = {
  title:          'steps',
  starting_at:    0,
  total:          100,
  progress_mark:  '#',
  remainder_mark: '_',
  length:         79,
  format:         '%t: %J%% [%B] %e',
}

unless File.exist?(ARGV[0].to_s)
  puts "USAGE: #{File.basename __FILE__} gamelist.xml"
  exit 0
end

repo = []
n  = Nokogiri::XML(File.open(ARGV[0])).css("game")
pb = ProgressBar.create(PROGRESSBAR_OPTIONS.merge total: n.size, title: "#{File.basename ARGV[0]} - #{n.size} roms ")
n.each do |m|
  pb.increment
  rom = m.css('path').first.try(:content)
  img = m.css('image').first.try(:content).to_s.sub(/.*\/(.+\/.+)$/, '\1').sub(/mame-libretro\//, 'mame/')
  
  if img.blank?
    repo << "\tNOTAG\t#{rom}"
  elsif !File.exist?("output/#{img}")
    repo << "\tNOIMG\t#{img}"
  end
end
puts repo[0..4]
